VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ADomainCache"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const LogMe As Boolean = False

Private Const MaxAge As Long = 7200000 '2 Stunden

Private Type ADomain
    HostName As String
    IP As Long
    Age As Long
End Type
Private DomainCache() As ADomain

Private Sub Class_Initialize()
    NewInstanz "ADomainCache"
    ReDim DomainCache(0) As ADomain
End Sub

Public Function GetDomainIP(ByVal HostName As String) As Long
    HostName = LCase$(HostName)
    RemoveOldDomains
    Dim X As Long
    For X = 1 To UBound(DomainCache)
        If HostName = DomainCache(X).HostName Then
            If LogMe Then Log "get domain """ + HostName + """ from cache"
            GetDomainIP = DomainCache(X).IP
            Exit Function
        End If
    Next
    GetDomainIP = INADDR_NONE
End Function

Private Sub RemoveOldDomains()
    Dim X As Long
    X = 1
    Do While X <= UBound(DomainCache)
        If timeGetTime() - DomainCache(X).Age > MaxAge Then
            RemoveDomain X
            X = X - 1
        End If
        X = X + 1
    Loop
End Sub

Private Sub RemoveDomain(Index As Long)
    If LogMe Then Log "remove domain """ + DomainCache(Index).HostName + """ from cache"
    DomainCache(Index) = DomainCache(UBound(DomainCache))
    ReDim Preserve DomainCache(UBound(DomainCache) - 1) As ADomain
End Sub

Public Sub RemoveBadDomain(ByVal HostName As String)
    HostName = LCase$(HostName)
    Dim X As Long
    For X = 1 To UBound(DomainCache)
        If HostName = DomainCache(X).HostName Then
            RemoveDomain X
            Exit Sub
        End If
    Next
End Sub

Public Sub AddDomain(ByVal HostName As String, IP As Long)
    HostName = LCase$(HostName)
    RemoveOldDomains
    Dim X As Long
    For X = 1 To UBound(DomainCache)
        If HostName = DomainCache(X).HostName Then
            DomainCache(X).Age = timeGetTime()
            Exit Sub
        End If
    Next
    If LogMe Then Log "add domain """ + HostName + """ to cache"
    ReDim Preserve DomainCache(UBound(DomainCache) + 1) As ADomain
    DomainCache(UBound(DomainCache)).HostName = HostName
    DomainCache(UBound(DomainCache)).IP = IP
    DomainCache(UBound(DomainCache)).Age = timeGetTime()
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "ADomainCache"
End Sub
