Attribute VB_Name = "HTTP_OPs"
Option Explicit

Public Type AhttpURL
    Domain As String
    Port As String
    HostName As String
    Path As String
    FullURL As String
End Type

Public Function GetFullAddress(ByVal NewAddress As String, OldAddress As String) As String
    If NewAddress = "" Then Exit Function
    NewAddress = Replace(NewAddress, "\", "/")
    If InStr(NewAddress, ":") <> 0 Then
        GetFullAddress = NewAddress
    Else
        If Left$(NewAddress, 1) = "/" Then
            GetFullAddress = GetMainURL(OldAddress) + NewAddress
        Else
            Dim Temp As String
            Dim F As Long
            Temp = GetAktDirURL(OldAddress)
            
CheckAgain:
            If AZLeftGleich(NewAddress, "..") Then
                Temp = GetAktDirURL(Left$(Temp, Len(Temp) - 1))
                NewAddress = Right$(NewAddress, Len(NewAddress) - 2)
                F = InStr(NewAddress, "/")
                If F <> 0 Then
                    NewAddress = Right$(NewAddress, Len(NewAddress) - F)
                    GoTo CheckAgain
                End If
            End If
            If AZLeftGleich(NewAddress, ".") Then
                NewAddress = Right$(NewAddress, Len(NewAddress) - 1)
                F = InStr(NewAddress, "/")
                If F <> 0 Then
                    NewAddress = Right$(NewAddress, Len(NewAddress) - F)
                    GoTo CheckAgain
                End If
            End If
            F = InStr(NewAddress, "/")
            If F <> 0 Then
                Temp = Temp + Left$(NewAddress, F)
                NewAddress = Right$(NewAddress, Len(NewAddress) - F)
                GoTo CheckAgain
            End If
            
            GetFullAddress = Temp + NewAddress
        End If
    End If
End Function

Public Function GetMainURL(ByVal TheAddress As String) As String
    TheAddress = Replace(TheAddress, "\", "/")
    If Len(TheAddress) >= 7 Then
        If UCase$(Left$(TheAddress, 7)) = "HTTP://" Then
            TheAddress = Right$(TheAddress, Len(TheAddress) - 7)
        End If
    End If
    Dim F As Integer
    F = InStr(TheAddress, "/")
    If F Then
        TheAddress = Left$(TheAddress, F - 1)
    End If
    GetMainURL = "http://" + TheAddress
End Function

Public Function GetAktDirURL(ByVal TheAddress As String) As String
    TheAddress = Replace(TheAddress, "\", "/")
    If Len(TheAddress) >= 7 Then
        If UCase$(Left$(TheAddress, 7)) = "HTTP://" Then
            TheAddress = Right$(TheAddress, Len(TheAddress) - 7)
        End If
    End If
    Dim X As Integer
    X = InStrRev(TheAddress, "/")
    If X <> 0 Then
        GetAktDirURL = "http://" + Left$(TheAddress, X)
    Else
        GetAktDirURL = "http://" + TheAddress + "/"
    End If
End Function

Public Function Convert_Text_To_PostData(ByVal TheText As String) As String
    TheText = Replace(TheText, " ", "+")
    
    Convert_Text_To_PostData = TheText
End Function

Public Function LinkIsCorrect(ByVal TheLink As String) As Boolean
    TheLink = UCase$(TheLink)
    If Len(TheLink) > 7 Then
        If Left$(TheLink, 7) = "HTTP://" Then
            LinkIsCorrect = True
            Exit Function
        End If
    End If
    LinkIsCorrect = False
End Function

Public Function GetServerFromURL(ByVal URL As String) As String
    URL = UCase$(Replace(URL, "\", "/"))
    If AZLeftGleich(URL, "HTTP://") Then URL = Right$(URL, Len(URL) - 7)
    Dim F As Long
    F = InStr(URL, "/")
    If F <> 0 Then URL = Left$(URL, F - 1)
    F = InStr(URL, ":")
    If F = 0 Then URL = URL + ":80"
    
    GetServerFromURL = URL
End Function

Public Function IPisOK(ByVal IP As String) As Boolean
    Dim F As Long
    IPisOK = False
    
    F = InStr(IP, ".")
    If F = 0 Then Exit Function
    If Not IsZahl(Left$(IP, F - 1), "") Then Exit Function
    If (Val(Left$(IP, F - 1)) < 0) Or _
       (Val(Left$(IP, F - 1)) > 255) Then Exit Function
    IP = Right$(IP, Len(IP) - F)
    
    F = InStr(IP, ".")
    If F = 0 Then Exit Function
    If Not IsZahl(Left$(IP, F - 1), "") Then Exit Function
    If (Val(Left$(IP, F - 1)) < 0) Or _
       (Val(Left$(IP, F - 1)) > 255) Then Exit Function
    IP = Right$(IP, Len(IP) - F)
    
    F = InStr(IP, ".")
    If F = 0 Then Exit Function
    If Not IsZahl(Left$(IP, F - 1), "") Then Exit Function
    If (Val(Left$(IP, F - 1)) < 0) Or _
       (Val(Left$(IP, F - 1)) > 255) Then Exit Function
    IP = Right$(IP, Len(IP) - F)
    
    If Not IsZahl(IP, "") Then Exit Function
    If (Val(IP) < 0) Or _
       (Val(IP) > 255) Then Exit Function
    
    IPisOK = True
End Function

Public Function Get_AhttpURL(ByVal URL As String) As AhttpURL
    If UCase$(Left$(URL, 7)) = "HTTP://" Then URL = Right$(URL, Len(URL) - 7)
    
    Dim F As Long
    
    F = InStr(URL, "/")
    If F = 0 Then
        Get_AhttpURL.Domain = URL
        Get_AhttpURL.Path = "/"
    Else
        F = F - 1
        Get_AhttpURL.Domain = Left$(URL, F)
        Get_AhttpURL.Path = Right$(URL, Len(URL) - F)
    End If
    
    F = InStr(Get_AhttpURL.Domain, ":")
    If F = 0 Then
        Get_AhttpURL.Port = 80
        Get_AhttpURL.HostName = Get_AhttpURL.Domain
        Get_AhttpURL.Domain = Get_AhttpURL.Domain + ":80"
    Else
        Get_AhttpURL.Port = Val(Right$(Get_AhttpURL.Domain, Len(Get_AhttpURL.Domain) - F))
        Get_AhttpURL.HostName = Left$(Get_AhttpURL.Domain, F - 1)
    End If

    Get_AhttpURL.FullURL = "http://" + Get_AhttpURL.Domain + Get_AhttpURL.Path
End Function

Function CookieVergleich(CookieVariable1 As httpCookieVariable, CookieVariable2 As httpCookieVariable) As Boolean
    If UCase$(CookieVariable1.Domain) = UCase$(CookieVariable2.Domain) Then
        If UCase$(CookieVariable1.Path) = UCase$(CookieVariable2.Path) Then
            If CookieVariable1.myName = CookieVariable2.myName Then
                CookieVergleich = True
                Exit Function
            End If
        End If
    End If
    CookieVergleich = False
End Function

Public Function GetCookieVariable(theName As String, theValue As String, myURL As String, Optional ByVal theDomain As String = "", Optional ByVal thePath As String = "", Optional theSecure As Boolean = False, Optional theExpires As String = "") As httpCookieVariable
    Set GetCookieVariable = New httpCookieVariable
    
    Dim httpURL As AhttpURL
    httpURL = Get_AhttpURL(myURL)
    If theDomain = "" Then
        theDomain = httpURL.Domain
        If InStr(theDomain, ":") = 0 Then
            theDomain = theDomain + ":80"
        End If
    End If
    If thePath = "" Then
        thePath = "/"
    End If
    
    GetCookieVariable.myName = theName
    GetCookieVariable.myValue = theValue
    GetCookieVariable.Path = thePath
    GetCookieVariable.Domain = theDomain
    GetCookieVariable.Expires = theExpires
    GetCookieVariable.Secure = theSecure
End Function

Public Function GetCookieVariableByString(Text As String, myURL As String) As httpCookieVariable
    ReDim Werte_Name(0) As String
    ReDim Werte_Value(0) As String
    Dim X As Long
    Dim Status As Integer
        '0 = nchster Wert_Name
        '1 = Wert
        '2 = nchster Wert_Value
    Status = 0
    For X = 1 To Len(Text)
        Select Case Mid$(Text, X, 1)
            Case "="
                Status = 2
            Case ";"
                Status = 0
            Case Else
                If Status = 0 Then
                    ReDim Preserve Werte_Name(UBound(Werte_Name) + 1) As String
                    ReDim Preserve Werte_Value(UBound(Werte_Value) + 1) As String
                    Status = 1
                End If
                If Status = 1 Then
                    Werte_Name(UBound(Werte_Name)) = Werte_Name(UBound(Werte_Name)) + Mid$(Text, X, 1)
                ElseIf Status = 2 Then
                    Werte_Value(UBound(Werte_Value)) = Werte_Value(UBound(Werte_Value)) + Mid$(Text, X, 1)
                End If
        End Select
    Next
    
    Dim theName As String
    theName = ""
    Dim theValue As String
    theValue = ""
    Dim theExpires As String
    theExpires = ""
    Dim thePath As String
    thePath = ""
    Dim theDomain As String
    theDomain = ""
    Dim theSecure As Boolean
    theSecure = False
    For X = 1 To UBound(Werte_Name)
        Werte_Name(X) = LTrim$(RTrim$(Werte_Name(X)))
        Werte_Value(X) = LTrim$(RTrim$(Werte_Value(X)))
        Select Case UCase$(Werte_Name(X))
            Case "EXPIRES"
                theExpires = Werte_Value(X)
            Case "PATH"
                thePath = Werte_Value(X)
            Case "DOMAIN"
                theDomain = Werte_Value(X)
            Case "SECURE"
                theSecure = True
            Case Else
                theName = Werte_Name(X)
                theValue = Werte_Value(X)
        End Select
    Next
    Set GetCookieVariableByString = GetCookieVariable(theName, theValue, myURL, theDomain, thePath, theSecure, theExpires)
End Function

Public Function GetCopyOfCookie(theCookie As httpCookie) As httpCookie
    Set GetCopyOfCookie = New httpCookie
    Dim X As Long
    For X = 1 To theCookie.GetAnzahlCookies()
        GetCopyOfCookie.NewCookie GetCopyOfCookieVariable(theCookie.GetCookie(X))
    Next
End Function

Public Function GetCopyOfCookieVariable(theCookieVariable As httpCookieVariable) As httpCookieVariable
    Set GetCopyOfCookieVariable = New httpCookieVariable
    GetCopyOfCookieVariable.Domain = theCookieVariable.Domain
    GetCopyOfCookieVariable.Expires = theCookieVariable.Expires
    GetCopyOfCookieVariable.myName = theCookieVariable.myName
    GetCopyOfCookieVariable.myValue = theCookieVariable.myValue
    GetCopyOfCookieVariable.Path = theCookieVariable.Path
    GetCopyOfCookieVariable.Secure = theCookieVariable.Secure
End Function

Public Function GetServerOfURLWithoutPort(ByVal URL As String) As String
    URL = Replace(URL, " ", "")
    If AZLeftGleich(UCase$(URL), "HTTP://") Then
        URL = Right$(URL, Len(URL) - 7)
    ElseIf AZLeftGleich(UCase$(URL), "FTP://") Then
        URL = Right$(URL, Len(URL) - 6)
    End If
    Dim F As Long
    F = InStr(URL, ":")
    If F = 0 Then F = InStr(URL, "/")
    If F = 0 Then
        GetServerOfURLWithoutPort = URL
    Else
        GetServerOfURLWithoutPort = Left$(URL, F - 1)
    End If
End Function
