VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PopClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Event GetState(ByVal NumberOfMails As Long)
Public Event DownloadReady(ByVal Index As Long)
Public Event DeleteReady(ByVal Index As Long)
Public Event Error(ByVal Number As Long, ByVal Description As String)
Public Event Closed()

Private myPort As Long
Private myHost As String
Private myUsername As String
Private myPassword As String

Private WithEvents Socket As CSocket_Client
Attribute Socket.VB_VarHelpID = -1

Private Status As Single

Private AllData As String

Private Mails() As AMail
Private Mails_State() As Integer
 '0 not downloaded
 '1 downloading
 '2 downloaded
 '3 deleting
 '4 deleted
Private AktMail As Long
Private Maillist() As String

Public Function GetMail(ByVal Index As Long) As AMail
 Set GetMail = Mails(Index)
End Function

Public Function GetMailState(ByVal Index As Long) As Integer
 GetMailState = Mails_State(Index)
End Function

Public Function GetMailsCount() As Long
 GetMailsCount = UBound(Mails)
End Function

Private Sub Class_Initialize()
 NewInstanz "PopClient"
 
 Set Socket = New CSocket_Client
 
 ReDim Mails(0) As AMail
 ReDim Mails_State(0) As Integer
End Sub

Private Sub Class_Terminate()
 ResetMails
 
 Set Socket = Nothing
 
 UnloadInstanz "PopClient"
End Sub

Private Sub ResetMails()
 Dim X As Long
 For X = 1 To UBound(Mails)
  Set Mails(X) = Nothing
 Next
 ReDim Mails(0) As AMail
 ReDim Mails_State(0) As Integer
End Sub

Private Sub Socket_Closed()
 RaiseEvent Closed
End Sub

Private Sub Socket_Connect()
 Status = 0
End Sub

Private Sub Socket_SendData(theData As String)
    Socket.SendData theData
End Sub

Public Function DownloadMail(ByVal Index As Long) As Boolean
 If (Status = 0.17) And (Mails_State(Index) = 0) Then
  AktMail = Index
  Mails_State(Index) = 1
  Socket_SendData "RETR " + LTrim$(RTrim$(Str$(Index))) + endl
  Status = 0.2
  DownloadMail = True
 Else
  DownloadMail = False
 End If
End Function

Public Function DeleteMail(ByVal Index As Long) As Boolean
 If (Status = 0.17) And (Mails_State(Index) = 2) Then
  AktMail = Index
  Mails_State(Index) = 3
  Socket_SendData "DELE " + LTrim$(RTrim$(Str$(Index))) + endl
  Status = 0.3
  DeleteMail = True
 Else
  DeleteMail = False
 End If
End Function

Public Function QuitConnection() As Boolean
 If Status = 0.17 Then
  Socket_SendData "QUIT" + endl
  Socket.Disconnect
  Status = 0
  QuitConnection = True
 Else
  QuitConnection = False
 End If
End Function

Private Sub Socket_DataArrival(BinData As String, RemoteHostIP As String)
 Dim Temp As String
 Dim X As Long
 Dim Y As Long
 Dim F As Long
 Dim AktLine As String
 Dim EndDataStr As String
 EndDataStr = Chr$(10) + "." + Chr$(10)
 
 Temp = Replace$(BinData, Chr$(13), "")
 AllData = AllData + Temp

CheckNextData:
 If Status = 2 Then 'Daten
   F = InStr(AllData, EndDataStr)
   If F Then 'Ende der Daten
    Mails(AktMail).Data = Mails(AktMail).Data + Left$(AllData, F - 1)
    AllData = Right$(AllData, Len(AllData) - F - Len(EndDataStr) + 1)
    Mails_State(AktMail) = 2
    Status = 0.17 'Warteschleife
    RaiseEvent DownloadReady(AktMail)
    GoTo CheckNextData
   Else 'neue Daten
    Mails(AktMail).Data = Mails(AktMail).Data + AllData
    AllData = ""
    Exit Sub
   End If
 End If
 
 F = InStr(AllData, Chr$(10))
 If F = 0 Then Exit Sub
 AktLine = Left$(AllData, F - 1)
 AllData = Right$(Temp, Len(AllData) - F)
 'Log "POP(" + GetServer() + "): " + AktLine
 
 If (Status < 1) And (Status <> 0.141) And (Status <> 0.161) Then  'Status
  If Not AZLeftGleich(UCase$(AktLine), "+OK") Then
   Socket_Error 0, AktLine
   Exit Sub
  End If
 End If
 
 Select Case Status
  Case 0 'allererste Daten
   Socket_SendData "USER " + myUsername + endl
   Status = 0.11
   GoTo CheckNextData
  Case 0.11 'Username gesendet, warte Besttigung und sende Passwort
   Socket_SendData "PASS " + myPassword + endl
   Status = 0.12
   GoTo CheckNextData
  Case 0.12 'Passwort gesendet, warte Besttigung und erfrage Status
   Socket_SendData "STAT" + endl
   Status = 0.13
   GoTo CheckNextData
  Case 0.13 'Status erfragt und OK, hole nun Mailliste
   Socket_SendData "UIDL" + endl
   Status = 0.14
   GoTo CheckNextData
  Case 0.14 'Mailliste folgt
   ReDim Maillist(0) As String
   Status = 0.141
   GoTo CheckNextData
  Case 0.141
   If LTrim$(RTrim$(AktLine)) = "." Then 'Mailliste zuende
    Y = 1
SearchNextMail:
    For X = 1 To UBound(Maillist)
     If AZLeftGleich(Maillist(X), LTrim$(RTrim$(Str$(Y))) + " ") Then
      ReDim Preserve Mails(Y) As AMail
      Set Mails(Y) = New AMail
      Mails(Y).MailNameOnServer = Right$(Maillist(X), Len(Maillist(X)) - Len(LTrim$(RTrim$(Str$(Y)))) - 1)
      ReDim Preserve Mails_State(Y) As Integer
      Mails_State(Y) = 0
      Y = Y + 1
      GoTo SearchNextMail
     End If
    Next
    Socket_SendData "LIST" + endl
    Status = 0.16
   Else 'neue Mail
    ReDim Preserve Maillist(UBound(Maillist) + 1) As String
    Maillist(UBound(Maillist)) = AktLine
   End If
   GoTo CheckNextData
  Case 0.16 'Infos kommen
   ReDim Maillist(0) As String
   Status = 0.161
   GoTo CheckNextData
  Case 0.161
   If LTrim$(RTrim$(AktLine)) = "." Then 'Infos zuende
    For Y = 1 To UBound(Mails)
     For X = 1 To UBound(Maillist)
      If AZLeftGleich(Maillist(X), LTrim$(RTrim$(Str$(Y))) + " ") Then
       Mails(Y).MailSize = Val(Right$(Maillist(X), Len(Maillist(X)) - Len(LTrim$(RTrim$(Str$(Y)))) - 1))
       GoTo NextMailInfo
      End If
     Next
     Mails(Y).MailSize = -1
NextMailInfo:
    Next
    Status = 0.17 'Warteschleife
    RaiseEvent GetState(UBound(Mails))
   Else 'neue Info ber Mail
    ReDim Preserve Maillist(UBound(Maillist) + 1) As String
    Maillist(UBound(Maillist)) = AktLine
   End If
   GoTo CheckNextData
  Case 0.2 'downloade Mail
   Status = 1
   GoTo CheckNextData
  Case 0.3 'lsche Mail
   Mails_State(AktMail) = 4
   Status = 0.17 'Warteschleife
   RaiseEvent DeleteReady(AktMail)
   GoTo CheckNextData
  Case 1 'Mailheader-Anfang
   If AZLeftGleich(LTrim$(UCase$(AktLine)), "REPLY-TO: ") _
   Or AZLeftGleich(LTrim$(UCase$(AktLine)), "FROM: ") Then
    Mails(AktMail).Headers.DeleteHeaders
    Status = 1.1
    GoTo StartOfMailheader
   End If
   GoTo CheckNextData
  Case 1.1 'Mailheader
StartOfMailheader:
   If LTrim$(RTrim$(AktLine)) = "" Then 'Ende des Headers
    Mails(AktMail).Data = ""
    Status = 2
   Else 'neuer Header
    F = InStr(AktLine, ": ")
    If F = 0 Then
     If Not Mails(AktMail).Headers.GetLastHeader Is Nothing Then
      Mails(AktMail).Headers.GetLastHeader.theValue _
          = Mails(AktMail).Headers.GetLastHeader.theValue _
            + endl + AktLine
     End If
     GoTo CheckNextData
    End If
    Mails(AktMail).Headers.NewHeader GetNewHeader(Left$(AktLine, F - 1), Right$(AktLine, Len(AktLine) - F - 1))
   End If
   GoTo CheckNextData
 End Select
 Exit Sub
 
Fehler:
 Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
 Resume Next
End Sub

Private Sub Socket_Error(Error As Long, Description As String)
 Socket.Disconnect
 StartProzess "Event PopClient_Error"
 On Error GoTo Fehler
 Log_ProzessInfo "Server=" + GetServer()
 Log_ProzessInfo "Nr: " + LTrim$(RTrim$(Str$(Error)))
 Log_ProzessInfo "Description: " + Description
 RaiseEvent Error(Error, Description)
 On Error GoTo 0
 EndProzess "Event PopClient_Error"
 Exit Sub
 
Fehler:
 Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
 Resume Next
End Sub

Public Sub Cancel() 'muss vor Terminate ausgefhrt werden!
 If Not Socket Is Nothing Then Socket.Cancel
End Sub

Public Function GetHost() As String
 GetHost = myHost
End Function

Public Function GetPort() As Long
 GetPort = myPort
End Function

Public Function GetServer() As String
 If myPort <> 110 Then
  GetServer = myHost + ":" + LTrim$(RTrim$(Str$(myPort)))
 Else
  GetServer = myHost
 End If
End Function

Public Sub CheckState(ByVal Username As String, ByVal Password As String, ByVal Host As String, Optional ByVal Port As Long = 110)
 ResetMails
 myHost = Host
 myPort = Port
 myUsername = Username
 myPassword = Password
 Socket.Connect Host, Port
End Sub
