Attribute VB_Name = "Timer_Modul"
Option Explicit

Private Declare Function timeKillEvent Lib "winmm.dll" (ByVal uID _
        As Long) As Long
                                
Private Declare Function timeSetEvent Lib "winmm.dll" (ByVal uDelay _
                                As Long, ByVal uResolution As Long, ByVal lpFunction _
                                As Long, ByVal dwUser As Long, ByVal uFlags As Long) _
                                As Long

Private Declare Function SetTimer Lib "user32" (ByVal hwnd As _
        Long, ByVal nIDEvent As Long, ByVal uElapse As Long, _
        ByVal lpTimerFunc As Long) As Long

Private Declare Function KillTimer Lib "user32" (ByVal hwnd As _
        Long, ByVal nIDEvent As Long) As Long
                                
Public Const TIME_ONESHOT = 0
Public Const TIME_PERIODIC = 1

Private Const TimerAPI As Integer = 1
'1 = SetTimer
'2 = timeSetEvent

Private RunningTimers As New Collection
Private AllTimers As New Collection
Private TimerFlag As String

Private Sub TimerProc1(ByVal uID As Long, ByVal uMsg As Long, _
                       ByVal dwUser As Long, ByVal dw1 As Long, ByVal dw2 As Long)
    If Not GetTimerFlag(uID) Then
        AddTimerFlag uID
        StartProzess "Event ATimer_Timer"
        On Error GoTo KillMe
        Log_ProzessInfo "TimerID = " & uID
        RunningTimers.Item(LTrim$(RTrim$(Str$(uID)))).RaiseEvent_Timer
        On Error GoTo 0
        EndProzess "Event ATimer_Timer"
        RemoveTimerFlag uID
    End If
    Exit Sub
    
KillMe:
    RemoveTimerFlag uID
    Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
    timeKillEvent uID
    Resume Next
End Sub

Private Sub TimerProc2(ByVal hwnd&, ByVal Msg&, ByVal idEvent&, ByVal dwTime&)
    If Not GetTimerFlag(idEvent&) Then
        AddTimerFlag idEvent&
        StartProzess "Event ATimer_Timer"
        On Error GoTo KillMe
        Log_ProzessInfo "TimerID = " & idEvent&
        RunningTimers.Item(LTrim$(RTrim$(Str$(idEvent&)))).RaiseEvent_Timer
        On Error GoTo 0
        EndProzess "Event ATimer_Timer"
        RemoveTimerFlag idEvent&
    End If
    Exit Sub
    
KillMe:
    RemoveTimerFlag idEvent&
    Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
    KillTimer 0, idEvent&
    Resume Next
End Sub

Public Function AddTimerEvent(TheTimer As ATimer, Delay As Long, Resolution As Long) As Long
    Dim TimerID As Long
    
    Select Case TimerAPI
        Case 1
            TimerID = SetTimer(0, 0, Delay, AddressOf TimerProc2)
        Case 2
            TimerID = timeSetEvent(Delay, Resolution, AddressOf TimerProc1, 0, TIME_PERIODIC)
    End Select
    RunningTimers.Add TheTimer, LTrim$(RTrim$(Str$(TimerID)))
    
    AllTimers.Add TimerID, LTrim$(RTrim$(Str$(TimerID)))
    
    AddTimerEvent = TimerID
End Function

Public Sub KillTimerEvent(TimerID As Long)
    Select Case TimerAPI
        Case 1
            KillTimer 0, TimerID
        Case 2
            timeKillEvent TimerID
    End Select
    RunningTimers.Remove LTrim$(RTrim$(Str$(TimerID)))
    AllTimers.Remove LTrim$(RTrim$(Str$(TimerID)))
End Sub

Public Sub KillAllTimerEvents()
    Dim X As Long
    For X = 0 To AllTimers.Count
        Select Case TimerAPI
            Case 1
                KillTimer 0, AllTimers.Item(X)
            Case 2
                timeKillEvent AllTimers.Item(X)
        End Select
    Next
End Sub

Public Sub init_TimerModul()
    TimerFlag = "|"
End Sub

Private Sub AddTimerFlag(TimerID As Long)
    TimerFlag = TimerFlag + LTrim$(RTrim$(Str$(TimerID))) + "|"
End Sub

Private Function GetTimerFlag(TimerID As Long) As Boolean
    GetTimerFlag = (InStr(TimerFlag, "|" + LTrim$(RTrim$(Str$(TimerID))) + "|") <> 0)
End Function

Private Sub RemoveTimerFlag(TimerID As Long)
    TimerFlag = Replace(TimerFlag, "|" + LTrim$(RTrim$(Str$(TimerID))) + "|", "|")
End Sub
